/*
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
********************** 504_Programm_2_dimensionales_Array *********************
-------------------------------------------------------------------------------
******************************* main.c ** V1.1 ********************************
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
 Anzeigen eines 2-dimensionalen Arrays auf dem 20x4-LCD
 Zusaetzliche Header..: keine
 Module.(*.c und *.h).: application, lcd_2wire, num_conversion
 Benoetigte Hardware..: Testboard, 20x4-LCD und 2-Draht-LCD-Interface
 Version..............: 1.1
 Compiler.............: CodeVisionAVR
 Chip.................: ATmega88
 Datum................: Juni 2009
 Autor................: Alwin Lenck (ALE23) basierend auf dem Projekt 
                        2-Draht-LCD von Udo Juerss
-------------------------------------------------------------------------------

Anschluesse des 20x4-LCD:
CLOCK................: PB1 (kann geaendert werden in application.h)
DATA.................: PB2 (kann geaendert werden in application.h)
*/

//-----------------------------------------------------------------------------
// Header-Dateien einfuegen:
//-----------------------------------------------------------------------------
#include "application.h"     // Initialisierung der Anwendung
#include "lcd_2wire.h"       // Initialisierung des 2Draht-LCDs
#include "num_conversion.h"  // Initialisierung der Konvertierung

//-----------------------------------------------------------------------------
// Funktions-Prototypen:
//-----------------------------------------------------------------------------
void output(int pary[]);     // Ausgabe-Funktion

//-----------------------------------------------------------------------------
// Globale Variablen:
//-----------------------------------------------------------------------------
int ary_2dim[3][4] =
  {{101, 102, 103, 104},     // Array-Initialisierung,
   {201, 202, 203, 204},     // zur besseren Uebersicht 
   {301, 302, 303, 304}};    // mehrfach geklammert
int i;                       // Schleifenzaehler

//-----------------------------------------------------------------------------
// Hauptprogramm main
//-----------------------------------------------------------------------------
void main(void)
{
// Die folgenden 2 Anweisungen stammen vom AVR-Projekt 2-Draht-LCD
  // Setzen des System-Taktes (CPU-Clock),
  // Ausschalten nicht benutzter Hardware-Module
  app_init();                // Initialisierung der Anwendung

  // Definition von Prototypen fuer LCD-Ausgabe-Funktionen usw.                
  lcd_init();                // Initialisierung des LCD-Interfaces

  for(i = 0; i < 3; i++)     // 3 Schleifen-Durchgaenge:
  {
    lcd_goto_xy(0,i);        // Cursor an den Anfang des LCD
                             // Spalte x = 0 und Zeile y = i 
    output(ary_2dim[i]);     //   1. Element von ary_2dim mit 4 Elementen
                             //   an die Anzeigefunktion lcd_write_S16(),
                             //   dann Zeiger inkrementieren.
                             // Schleife 2: Uebergabe des Pointers auf das
                             //   2. Element von ary_2dim mit 4 Elementen
                             //   an die Anzeigefunktion lcd_write_S16(),
                             //   dann Zeiger inkrementieren.
                             // Schleife 3: Uebergabe des Pointers auf das
                             //   3. Element von ary_2dim mit 4 Elementen
                             //   an die Anzeigefunktion lcd_write_S16(),
                             //   dann Zeiger inkrementieren und
                             //   Feststellen des Endes der Schleife.
  }
  while(1);                  // Endlos-Schleife ohne weitere Anweisungen
}

//-----------------------------------------------------------------------------
// Ausgabe-Funktion
//-----------------------------------------------------------------------------
void output(int pary[])      // Die Funktion gibt die Elemente eines 
                             // einzelnen Arrays mit 4 Elementen aus.
{
  int i;                     // Schleifenzaehler
  int *p;                    // Pointer auf Integer
  p = (int *)pary;           // Um p die Adresse in pary zuweisen zu
                             // koennen, ist eine Typumwandlung von pary
                             // von
                             // Pointer auf ein Array von 3 int-Elementen
                             // nach
                             // Pointer auf int notwendig!
  for(i = 0; i < 4; i++)     // 4 Werte ausgeben:
  {
    lcd_write_S16(*p++, 5);  // 5-stellige Zahl ausgeben, ggf. mit
  }                          // vorlaufenden Leerstellen
                             // Pointer inkrementieren
                             // und auf naechstes Element im Array zeigen.
}
//-----------------------------------------------------------------------------
